﻿define([
    "dojo/_base/array",
    "dojo/_base/declare",
    "dojo/_base/lang"
],

function (
    array,
    declare,
    lang
) {

    // summary:
    //      Handles validation stuffs
    // tags:
    //      public

    return declare(null, {

        _watchHandles: null,

        constructor: function () {
            this._watchHandles = [];
        },

        destroy: function () {
            array.forEach(this._watchHandles, function (handle) {
                handle.unwatch();
            });
            this._watchHandles = null;

            this.inherited(arguments);
        },

        _addStateWatch: function (/*Object*/widget) {
            var propertyName = widget.get("name"),
                viewModel = this.viewModel;

            var update = function () {
                var state = widget.get("state");
                if (state !== "Error") {
                    viewModel.validator.clearPropertyErrors(propertyName, viewModel.validator.validationSource.client);
                } else if (state === "Error") {
                    var errorMessage = widget.get("message");
                        errorMessage === "" && (errorMessage = widget.getErrorMessage());
                    viewModel.validator.setPropertyErrors(
                        propertyName, [{
                            "severity": viewModel.validator.severity.error,
                            "errorMessage": errorMessage
                        }],
                        viewModel.validator.validationSource.client
                    );
                }
            };

            this._watchHandles.push(widget.watch("state", update));
            this._watchHandles.push(widget.watch("message", update));
        }
    });
});