﻿define([
//dojo
    "dojo/_base/declare",
//dijit
    "dijit/_Widget",
    "dijit/_TemplatedMixin",
    "dijit/_Container",
    "dijit/_Contained",
//resources
    "dojo/text!./templates/_HyperLinkFieldItem.html"
],
function (
//dojo
    declare,
//dijit
    _Widget,
    _TemplatedMixin,
    _Container,
    _Contained,
//resources
    template
    ) {
    return declare([_Widget, _Container, _Contained, _TemplatedMixin], {
        templateString: template,

        // Represents widget to input link value
        inputWidget: null,

        // Settings for child widget
        settings: [],

        _onRadioButtonChange: function (evt) {
            this.onRadioButtonChange(this, evt);
        },

        onRadioButtonChange: function (target, evt) {
            // trigger radio button change value event
        },

        addChild: function (child) {
            this.inputWidget = child;

            this.inherited(arguments);
        },

        validate: function () {
            return this.inputWidget ? this.inputWidget.validate() : false;
        },

        _setValueAttr: function (value) {
            if (this.inputWidget) {
                this.inputWidget.set("value", value);
            }
        },

        _getValueAttr: function () {
            return this.inputWidget.get("value");
        },

        _setRequiredAttr: function (val) {
            if (this.inputWidget) {
                this.inputWidget.set("required", val);
            }
        },

        _setSelectedAttr: function (value) {
            if (this.inputWidget) {
                this.inputWidget.set("disabled", !value);
                this.radioNode.checked = value;
            }
        },

        _getSelectedAttr: function () {
            return this.radioNode.checked;
        },

        _setShowAllLanguagesAttr: function (val) {
            if (this.inputWidget) {
                this.inputWidget.set("showAllLanguages", val);
            }
        },

        focus: function () {
            if (this.inputWidget) {
                this.inputWidget.focus();
            }
        }
    });
});