﻿define([
"dojo",
"dijit",
"epi",
"epi/dependency",
"epi/routes",
"dijit/_WidgetBase",
"dijit/_Container"],

function (dojo, dijit, epi, dependency, routes, _WidgetBase, _Container) {

    return dojo.declare([_WidgetBase, _Container], {
        //  summary:
        //      Application widget. Responsible for loading and creating widgets
        //

        // viewNodes: DomNode[]
        //  Nodes where to inject loaded components
        viewNodes: null,

        _componentController: null,

        constructor: function () {
            this.viewNodes = [];
        },

        postMixInProperties: function () {
            // tags:
            //      protected

            this.inherited(arguments);

            this._componentController = dependency.resolve("epi.shell.controller.Components");
        },

        postCreate: function () {
            // tags:
            //      protected
            //
            this.inherited(arguments);

            this.viewNodes = [this.containerNode];
        },


        startup: function () {
            this.inherited(arguments);
            console.log("application startup");

            dojo.when(this._componentController.loadComponents(this.viewNodes), dojo.hitch(this, function (widgets) {
                // used to fix visual glitches on Chrome.
                dojo.forEach(this.viewNodes, function (nodeId) {
                    var domNode = dojo.byId(nodeId);
                    var widget = dijit.getEnclosingWidget(domNode);
                    if (widget) {
                        if (dojo.isFunction(widget.resize)) {
                            widget.resize();
                        }
                    }
                });

                dojo.forEach(widgets, function (widget) {
                    if (dojo.isFunction(widget.resize)) {
                        widget.resize();
                    }
                });
            }), function (e) {
                console.error(e.stack || e);
            });
        }


    });
});

